import os
import sys
current_dir = os.path.dirname(__file__)
parent_dir = os.path.abspath(os.path.join(current_dir, '..'))
sys.path.append(parent_dir)
from flask import json
from bson import json_util

# get_markers requests all marker data from mongoDB
def get_all_markers(self, col):
    try:
        # Fetch marker data from DB
        marker_cursor = col.find({})
        marker_data = list(marker_cursor)
                
        # Remove ObjectId field documents to allow for easy JSON to BSON conversion
        for document in marker_data:
            document.pop('_id', None)

        if marker_data: # Data found in DB, convert from BSON to JSON
            resp_code = 200 
            marker_json_list = [json_util.dumps(document) for document in marker_data]
            marker_json = "[" + ",".join(marker_json_list) + "]" 
        else: # Data not found in DB
            resp_code = 404 
            marker_json = '[]' 
    except Exception as e:
        print(f"An error occurred while querying MongoDB: {e}")
        resp_code = 500
        marker_data = []

    # Set headers
    self.send_response(resp_code)
    self.send_header("Content-type", "application/json")
    self.end_headers()

    # Convert marker_data to JSON and write it to the response object
    marker_json = json.dumps(marker_data)
    self.wfile.write(marker_json.encode('utf-8'))
